;##################################################################
;
;   ZMercury (title screen)
;                                                                     
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated November 28, 2004.
;
;##################################################################

title_screen:
        ROM_CALL(CLEARLCD)
#ifdef NARROW
        ld      hl,$001
        ld      (CURSOR_ROW),hl
        ld      hl,title1
        ROM_CALL(D_ZT_STR)
        ld      hl,$005
        ld      (CURSOR_ROW),hl
        ld      hl,title6
        ROM_CALL(D_ZT_STR)
#else
        ld      hl,$401
        ld      (CURSOR_ROW),hl
        ld      hl,title1
        ROM_CALL(D_ZT_STR)
        ld      hl,$102
        ld      (CURSOR_ROW),hl
        ld      hl,title2
        ROM_CALL(D_ZT_STR)
        ld      hl,$206
        ld      (CURSOR_ROW),hl
        ld      hl,title6
        ROM_CALL(D_ZT_STR)
#endif

#ifdef NARROW
        ld      hl,(terr_buffer)
        call    Read_LCD
        ld      hl,(terr_buffer)
        ld      bc,TERRAIN_SIZE
invert_loop:
        ld      a,(hl)
        cpl
        ld      (hl),a
        inc     hl
        dec     bc
        ld      a,b
        or      c
        jr      nz,invert_loop
#else
        ld      hl,(terr_buffer)
        ld      de,BUFF_WIDTH*TERRAIN_SKIP
        add     hl,de
        ld      de,$fc00
        ld      b,VISIBLE_HEIGHT
loop_copy_outer:
        push    bc
        ld      b,16
loop_copy_inner:
        ld      a,(de)
        inc     de
        cpl
        ld      (hl),a
        inc     hl
        djnz    loop_copy_inner
        pop     bc
        inc     hl
        djnz    loop_copy_outer
#endif

title_loop:   
        call    scroll_stars
        call    draw_background
        call    wait_next_frame
        call    display_buffer
        call    adjust_contrast
        call    OTH_ARROW
        bit     6,a
        jr      z,title_quit
        bit     5,a
        jr      nz,title_loop

        ld      hl,(terr_buffer)
        ld      (hl),-1
        ld      bc,TERRAIN_SIZE-1
        jp      OTH_FILL

title_quit:
        pop     hl
        jp      game_over

#ifdef NARROW
title1: .db     "ZMercury 0.34 by"
        .db     "Patrick Davidson",0
title6: .db     "Push 2ND to play",0
#else
title1: .db     "ZMercury 0.34",0
title2: .db     "by Patrick Davidson",0
title6: .db     "Press 2ND to play",0
#endif
