;##################################################################
;
;   Z M E R C U R Y     F O R     T I - 8 3     P L U S     I O N
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated December 2, 2004.
;
;##################################################################     

#define TI83P
#define NARROW

#include    "ion.inc"

K_EXIT          =$37
K_DEL           =$38
K_ENTER         =9
TEXT_MEM        =saferam3
CONTRAST        =contrast
                           
#define ROM_CALL(this_or_that) bcall(this_or_that)
D_ZT_STR        =_puts
D_HL_DECI       =_disphl
TX_CHARPUT      =_putc
CLEARLCD        =_clrlcdf
CURSOR_ROW      =currow
CURSOR_COL      =curcol
D_ZM_STR        =_vputs
CURSOR_X        =pencol
                            
interrupt_entry =$9898
interrupt_byte  =$98
interrupt_table =$9900
interrupt_reg   =$99

free_memory             =$9820

#include "zmercury.i"
#include "keys.i"

        .org    progstart-2
        .db     $BB,$6D

        ret
        jr      nc,start

        .db     "ZMercury 0.34",0

start:  ld      (iy+13),0               ;don't overwrite text memory

        ld      hl,TERRAIN_SIZE*2
        bcall(_enoughRam)
        jr      nc,no_whining

whine_about_memory:
        ld      hl,whining_message
        bcall(_puts)
        call    GET_KEY
loop_wait_whine:
        call    GET_KEY
        or      a
        jr      z,loop_wait_whine
        ret 
whining_message:
        .db     "ERROR:  You need"
        .db     "at least 1664   "
        .db     "bytes of free   "
        .db     "memory!",0

no_whining:
        ld      hl,graph_mem
        ld      (star_buffer),hl
        ld      hl,(free_memory)
        ld      (_GFX_BUFFER),hl
        ld      de,TERRAIN_SIZE
        add     hl,de
        ld      (terr_buffer),hl

;############## Include remainder of game files

#include "zmerc.asm"
#include "lib.asm"
#include "gfx.asm"
#include "terrain.asm"
#include "drwspr.asm"
#include "images.asm"
#include "player.asm"
#include "bullets.asm"
#include "vars.asm"
#include "info.asm"
#include "enemies.asm"
#include "entry.asm"
#include "collide.asm"
#include "hitenemy.asm"
#include "ebullets.asm"
#include "eshoot.asm"
#include "scores.asm"
#include "title.asm"
#include "lib12.asm"
#include "non85.asm"

        .end
